// lista1.c - Definicije paketa funkcija za obradu listi (iterativno).

#include "lista.h"
#include <stdio.h>
#include <stdlib.h>

int duz(Elem *lst) {                   // Broj elemenata liste.
  int n = 0;
  while (lst) { n++; lst = lst -> sled; }
  return n;
}

void pisi(Elem *lst) {                 // Ispisivanje liste.
  while (lst) { printf("%d ", lst->broj); lst = lst -> sled; }
}

Elem *na_pocetak(Elem *lst, int b) {   // Dodavanje na poetak.
  Elem *novi = malloc(sizeof(Elem));
  novi->broj = b; novi->sled = lst;
  lst = novi;
  return lst;
}
 
Elem *na_kraj(Elem *lst, int b) {      // Dodavanje na kraj.
  Elem *novi = malloc(sizeof(Elem));
  novi->broj = b; novi->sled = NULL;
  if (!lst) return novi;
  else {
    Elem *tek = lst;
    while (tek->sled) tek = tek->sled;
    tek->sled = novi;
    return lst;
  }
}

Elem *citaj1(int n) {   // itanje liste stavljajui brojeve na poetak.
  Elem *prvi = NULL;
  for (int i=0; i<n; i++) {
    Elem *novi = malloc(sizeof(Elem));
    scanf("%d", &novi->broj);
    novi->sled = prvi;
    prvi = novi;
  }
  return prvi;
}

Elem *citaj2(int n) {   // itanje liste stavljajui brojeve na kraj.
  Elem *prvi = NULL, *posl = NULL;
  for (int i=0; i<n; i++) {
    Elem *novi = malloc(sizeof(Elem));
    scanf("%d", &novi->broj); novi->sled = NULL;
    if (!prvi) prvi = novi; else posl->sled = novi;
    posl = novi;
  }
  return prvi;
}

Elem *umetni(Elem *lst, int b) {       // Umetanje u ureenu listu.
  Elem *tek=lst, *pret=NULL;
  while (tek && tek->broj < b)
    { pret = tek; tek = tek->sled; }
  Elem *novi = malloc(sizeof(Elem));
  novi->broj = b; novi->sled = tek;
  if (!pret) lst = novi;
    else pret->sled = novi;
  return lst;
}

void brisi(Elem *lst) {                // Brisanje svih elemenata liste.
  while (lst) {
    Elem *stari = lst;
    lst = lst->sled;
    free(stari);
  }
}
 
Elem *izostavi(Elem *lst, int b){ // Izostavljanje svakog pojavljivanja.
  Elem *tek = lst, *pret = NULL;
  while (tek)
    if (tek->broj != b) {
      pret = tek; tek = tek->sled;
    } else {
      Elem *stari = tek;
      tek = tek->sled; 
      if (!pret) lst = tek;
        else pret->sled = tek;
      free(stari);
    }
  return lst;
}
