// stablo.h - Deklaracije paketa za obradu sa binarnih stabala.

typedef struct cvor { int broj; struct cvor *levo, *desno; } Cvor;
typedef Cvor *Stablo;

Stablo stvori  (void);                  // Stvaranje praznog stabla.
int    vel     (Stablo stb);            // Broj vorova u stablu.
int    zbir    (Stablo stb);            // Zbir brojeva u stablu.
void   pisi_kld(Stablo stb);            // Prefiksno ispisivanje.
void   pisi_lkd(Stablo stb);            // Infiksno ispisivanje.
void   pisi_ldk(Stablo stb);            // Postfiksno ispisivanje.
void   crtaj   (Stablo stb, int nivo);  // Grafiki prikaz stabla.
int    pojav   (Stablo stb, int b);     // Broj pojavljivanja u stablu.
int    min_u   (Stablo stb);            // Najmanji u ureenom stablu.
int    max_u   (Stablo stb);            // Najvei u ureenom stablu.
int    min_n   (Stablo stb);            // Najmanji u neureenom stablu.
int    max_n   (Stablo stb);            // Najvei u neureenom stablu.
_Bool  uredjeno(Stablo stb);            // Da li je stablo ureeno?
Cvor  *nadji_u (Stablo stb, int b);     // Traenje u ureenom stablu.
Cvor  *nadji_n (Stablo stb, int b);     // Traenje u neureenom stablu.

Stablo dodaj_u (Stablo stb, int b);     // Dodavanje u ureeno stablo.
Stablo dodaj_n (Stablo stb, int b);     // Dodavanje u neureeno stablo.
Stablo citaj_u (int n);                 // itanje ureenog stabla.
Stablo citaj_n (int n);                 // itanje neureenog stabla.
Stablo brisi   (Stablo stb);            // Brisanje celog stabla.
Stablo izost_u (Stablo stb, int b);     // Izost. iz ureenog stabla.
Stablo izost_n (Stablo stb, int b);     // Izost. iz neureenog stabla.
Stablo balans_u(Stablo stb);            // Balansiranje ureenog stabla.
Stablo balans_n(Stablo stb);            // Balansiranje neureenog stabla.
